blob: 2ccc75c8a77d234749898f9eecdac6f310ef9020 [file] [log] [blame]
Miguel Osorio03f2e232019-09-17 19:44:37 -07001#!/bin/bash
2# Copyright lowRISC contributors.
3# Licensed under the Apache License, Version 2.0, see LICENSE for details.
4# SPDX-License-Identifier: Apache-2.0
5
6set -o errexit
7set -o pipefail
8set -o nounset
9
Miguel Young de la Sota4a4946d2019-11-21 10:44:18 -060010# meson_init.sh configures OpenTitan's Meson build system. Rather than calling
11# Meson directly, this script should be used instead, since it handles things
12# that Meson does not out of the box, such as:
13# - The RISC-V toolchain.
14# - Idempotence.
15# - Building for multiple device platforms.
16#
17# This script's semantics for creating build directories are as follows:
18# - By default, this script will create any missing build directories and
19# configure them. It is idempotent: if there is no work to be done, nothing
20# will change and this script will exit successfully.
21# - Passing -r will reconfigure existing build directories. This should be used
22# when editing meson.build files.
23# - Passing -f will erase existing build directories. This should be used when
24# existing configuration is completely broken, or a clean build is desired
25# (neither of these should be necessary).
26# - Passing -A will explicitly disable idempotence, and cause the script to exit
27# if a build directory already exists. This should be used only in CI, where
28# such error-checking is desireable.
29#
30# Note that only the first option above is actually guaranteed to be idempotent.
31
Miguel Young de la Sota63793572019-11-13 14:18:51 -060032. util/build_consts.sh
33
34echo "Detected \$REPO_TOP at $REPO_TOP."
35echo "Object directory set at $OBJ_DIR."
36echo "Binary directory set at $BIN_DIR."
Miguel Young de la Sotab2ef4832019-11-22 12:55:46 -060037echo "OpenTitan version: $OT_VERSION"
Miguel Young de la Sota63793572019-11-13 14:18:51 -060038echo
Miguel Osorio03f2e232019-09-17 19:44:37 -070039
40function usage() {
41 cat << USAGE
42Configure Meson build targets.
43
Sam Elliottc09da262020-06-03 11:10:36 +010044Usage: $0 [-r|-f|-A|-K|-T|-t]
Miguel Osorio03f2e232019-09-17 19:44:37 -070045
Miguel Young de la Sota4a4946d2019-11-21 10:44:18 -060046 -f: Force a reconfiguration by removing existing build dirs.
47 -r: Reconfigure build dirs, if they exist.
48 -A: Assert that no build dirs exist when running this command.
Miguel Young de la Sota3fbb28a2019-10-16 15:15:07 -050049 -K: Keep include search paths as generated by Meson.
Sam Elliottc09da262020-06-03 11:10:36 +010050 -t FILE: Configure Meson with toolchain configuration FILE
Jon Flatleya863a282020-03-03 10:49:39 -050051 -T PATH: Build tock from PATH rather than the remote repository.
Alphan Ulusoyd2bbbe12020-08-14 15:39:51 -040052 -c: Enable coverage (requires clang).
Miguel Osorio03f2e232019-09-17 19:44:37 -070053
54USAGE
55}
56
Sam Elliottc09da262020-06-03 11:10:36 +010057readonly DEFAULT_RISCV_TOOLS=/tools/riscv
58TOOLCHAIN_PATH="${TOOLCHAIN_PATH:-$DEFAULT_RISCV_TOOLS}"
59
Miguel Young de la Sota4a4946d2019-11-21 10:44:18 -060060FLAGS_assert=false
Miguel Osorio03f2e232019-09-17 19:44:37 -070061FLAGS_force=false
62FLAGS_reconfigure=""
Miguel Young de la Sota3fbb28a2019-10-16 15:15:07 -050063FLAGS_keep_includes=false
Sam Elliottc09da262020-06-03 11:10:36 +010064FLAGS_specified_toolchain_file=false
Alphan Ulusoyd2bbbe12020-08-14 15:39:51 -040065FLAGS_coverage=false
Luís Marques5849cd12020-06-26 10:33:55 +010066ARG_toolchain_file="${TOOLCHAIN_PATH}/meson-riscv32-unknown-elf-clang.txt"
Jon Flatleya863a282020-03-03 10:49:39 -050067ARG_tock_dir=""
Alphan Ulusoyd2bbbe12020-08-14 15:39:51 -040068while getopts 'r?:f?:K?:A?:T:t:c?' flag; do
Miguel Osorio03f2e232019-09-17 19:44:37 -070069 case "${flag}" in
70 f) FLAGS_force=true;;
71 r) FLAGS_reconfigure="--reconfigure";;
Miguel Young de la Sota4a4946d2019-11-21 10:44:18 -060072 A) FLAGS_assert=true;;
Miguel Young de la Sota3fbb28a2019-10-16 15:15:07 -050073 K) FLAGS_keep_includes=true;;
Sam Elliottc09da262020-06-03 11:10:36 +010074 t) FLAGS_specified_toolchain_file=true
75 ARG_toolchain_file="${OPTARG}";;
Jon Flatleya863a282020-03-03 10:49:39 -050076 T) ARG_tock_dir="${OPTARG}";;
Alphan Ulusoyd2bbbe12020-08-14 15:39:51 -040077 c) FLAGS_coverage=true;;
Miguel Osorio03f2e232019-09-17 19:44:37 -070078 ?) usage && exit 1;;
Jon Flatleya863a282020-03-03 10:49:39 -050079 :) usage
80 error "${OPTARG} requires a path argument"
81 ;;
Miguel Osorio03f2e232019-09-17 19:44:37 -070082 *) usage
83 error "Unexpected option ${flag}"
84 ;;
85 esac
86done
87
Miguel Osorio03f2e232019-09-17 19:44:37 -070088if [[ ! -n "$(command -v meson)" ]]; then
89 echo "Unable to find meson. Please install meson before running this command." >&2
90 exit 1
91fi
92
93if [[ ! -n "$(command -v ninja)" ]]; then
94 echo "Unable to find ninja. Please install ninja before running this command." >&2
95 exit 1
96fi
97
98if [[ "${FLAGS_force}" == true ]]; then
Miguel Young de la Sota4a4946d2019-11-21 10:44:18 -060099 rm -rf "$OBJ_DIR"
100 rm -rf "$BIN_DIR"
Miguel Osorio03f2e232019-09-17 19:44:37 -0700101fi
102
Miguel Young de la Sota4a4946d2019-11-21 10:44:18 -0600103if [[ "${FLAGS_assert}" == true ]]; then
104 if [[ -e "$OBJ_DIR" ]]; then
105 echo "Object directory at $OBJ_DIR already exists. Aborting." >&2
106 exit 1
107 fi
108 if [[ -e "$BIN_DIR" ]]; then
109 echo "Binary directory at $BIN_DIR already exists. Aborting." >&2
110 exit 1
111 fi
Miguel Osorio03f2e232019-09-17 19:44:37 -0700112fi
113
Jon Flatleya863a282020-03-03 10:49:39 -0500114TOCK_LOCAL=false
115if [[ ! -z "${ARG_tock_dir}" ]]; then
116 TOCK_LOCAL=true
117
118 if [[ ! -d "${ARG_tock_dir}" ]]; then
119 echo "Referenced Tock directory ${ARG_tock_dir} doesn't exist. Aborting." >&2
120 exit 1
121 fi
122
123 if [[ ! -f "${TOCK_SYMLINK}" || -L "${TOCK_SYMLINK}" ]]; then
124 echo "Creating symlink to Tock project at ${ARG_tock_dir}."
125 ln -sf "${ARG_tock_dir}" "${TOCK_SYMLINK}"
126 elif [[ -d "${TOCK_SYMLINK}" ]]; then
127 echo "Tock directory $TOCK_SYMLINK exists in place. Leaving as is."
128 else
129 echo "Placing Tock at ${TOCK_SYMLINK} would clobber something. Aborting." >&2
130 exit 1
131 fi
132fi
133
Miguel Young de la Sota76526c32020-01-28 10:24:41 -0500134reconf="${FLAGS_reconfigure}"
Miguel Young de la Sota4a4946d2019-11-21 10:44:18 -0600135
Miguel Young de la Sota76526c32020-01-28 10:24:41 -0500136if [[ ! -d "$OBJ_DIR" ]]; then
137 echo "Output directory does not exist at $OBJ_DIR; creating." >&2
138 mkdir -p "$OBJ_DIR"
139 reconf=""
140elif [[ -z "$reconf" ]]; then
141 echo "Output directory already exists at $OBJ_DIR; skipping." >&2
Miguel Young de la Sota76526c32020-01-28 10:24:41 -0500142fi
Miguel Young de la Sota4a4946d2019-11-21 10:44:18 -0600143
Sam Elliott36fe3b52020-08-17 17:21:24 +0100144if [[ -f "${ARG_toolchain_file}" ]]; then
145 echo "Using meson toolchain file at $ARG_toolchain_file." >&2
146else
147 if [[ "${FLAGS_specified_toolchain_file}" == true ]]; then
148 echo "Unable to find meson toolchain file at $ARG_toolchain_file. Aborting." >&2
149 exit 1
150 else
151 cross_file="$OBJ_DIR/toolchain-configured.txt"
152 cp toolchain.txt "$cross_file"
153 perl -pi -e "s#$DEFAULT_RISCV_TOOLS#$TOOLCHAIN_PATH#g" "$cross_file"
154 touch -r toolchain.txt "$cross_file"
155 echo "Set up toolchain file at $cross_file." >&2
156 ARG_toolchain_file="${cross_file}"
157 fi
158fi
159
Miguel Young de la Sota76526c32020-01-28 10:24:41 -0500160mkdir -p "$DEV_BIN_DIR"
161set -x
162meson $reconf \
163 -Dot_version="$OT_VERSION" \
164 -Ddev_bin_dir="$DEV_BIN_DIR" \
165 -Dhost_bin_dir="$HOST_BIN_DIR" \
Jon Flatleya863a282020-03-03 10:49:39 -0500166 -Dtock_local="$TOCK_LOCAL" \
Sam Elliott371c79f2020-06-23 20:06:19 +0100167 -Dkeep_includes="$FLAGS_keep_includes" \
Alphan Ulusoyd2bbbe12020-08-14 15:39:51 -0400168 -Dcoverage="$FLAGS_coverage" \
Sam Elliottc09da262020-06-03 11:10:36 +0100169 --cross-file="$ARG_toolchain_file" \
Miguel Young de la Sota76526c32020-01-28 10:24:41 -0500170 "$OBJ_DIR"